/*
 * Exemplo de uso de fork e waitpid.
 */ 

#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <stdio.h>

int main() {
  pid_t pid;

  printf("Processo pai. PID = %d\n", getpid());
  
  if ((pid = fork()) != 0) {
    printf("Processo pai. PID do filho = %d\n", pid);
    while (waitpid(pid, NULL, WNOHANG)== 0)  
      printf("Meu filho ainda no morreu\n");
    printf("Meu filho morreu\n");
  }
  else {
    sleep(1); /* Filho demora um pouco para executar. */
    printf("Processo filho. PID = %d\n", getpid());
  } 
  return 0;
}  
  
